<!doctype html>
<html>
<head>
    <title>Tor’s Bug Smash Fund: Progress Since January 2020 | The Tor Project</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="monetization" content="$ilp.uphold.com/pYfXb92JBQN4">
    <link rel="stylesheet" href="../static/css/style.css?h=5fc6c25a">
    <link rel="stylesheet" href="../static/fonts/fontawesome/css/all.min.css?h=9d272f6a">
    <link rel="stylesheet" href="../static/pygments.css">
    <link rel="icon" type="image/x-icon" href="../static/images/favicon/favicon.ico">
    <link rel="icon" type="image/png" href="../static/images/favicon/favicon.png">
    <meta property="og:title" content="Tor’s Bug Smash Fund: Progress Since January 2020 | Tor Project">
    <meta property="og:description" content="At the beginning of August 2019, we asked you to help us build our very first Bug Smash Fund. This fund will ensure that the Tor Project has a healthy reserve earmarked for maintenance work and smashing the bugs necessary to keep Tor Browser, the Tor network, and the many tools that rely on Tor strong, safe, and running smoothly. We want to share a final update on the work the 2019 Bug Smash Fund made possible.">
    <meta property="og:image" content="https://blog.torproject.org/tor-bug-smash-fund-2019-final-update/lead.png">
    <meta property="og:url" content="https://blog.torproject.org/tor-bug-smash-fund-2019-final-update/">
    <meta name="twitter:card" content="summary_large_image">
</head>
<body>
  <header>
    <nav>
      <a class="navbar-brand" href="../"><img alt="Tor Blog" src="../static/images/logo.png" /></a>
      <ul class="navbar-nav">
          <li><a href="https://www.torproject.org/about/history/">About</a></li>
          <li><a href="https://support.torproject.org/">Support</a></li>
          <li><a href="https://community.torproject.org/">Community</a></li>
          <li><a href="https://forum.torproject.org/">Forum</a></li>
          <li><a href="https://donate.torproject.org/">Donate</a></li></ul>
    </nav>
  </header>
  <section class="content">
    <main>
  <article class="blog-post">
      <h1 class="title">
        Tor’s Bug Smash Fund: Progress Since January 2020
      </h1>
    <p class="meta">by <a href="../author/alsmith">alsmith</a> | July 17, 2020</p>
    <picture>
      
      <img class="lead" src="lead.png">
    </picture>
    <div class="body">
      <link rel="stylesheet" href="../static/css/legacy.css?h=21ddbb2d">
      <p>At the beginning of August 2019, we asked you to help us build our <a href="https://blog.torproject.org/tors-bug-smash-fund-help-tor-smash-all-bugs">very first Bug Smash Fund</a>. This fund will ensure that the Tor Project has a healthy reserve earmarked for maintenance work and smashing the bugs necessary to keep Tor Browser, the Tor network, and the <a href="https://blog.torproject.org/strength-numbers-entire-ecosystem-relies-tor">many tools that rely on Tor</a> strong, safe, and running smoothly. Together we raised $86,081.</p>
<p>We want to share a final update on the work the 2019 Bug Smash Fund made possible.</p>
<p>Over the last year, we’ve marked 93 tickets with <a href="https://gitlab.torproject.org/tpo/applications/tor-browser/-/issues?label_name%5B%5D=BugSmashFund&amp;scope=all&amp;state=all">BugSmashFund</a>. As of today, 74 of those tickets have been closed, and 19 of them are still in progress. With this reserve, we’ve been able to fix bugs and complete necessary maintenance on our mechanisms for sending bridges via email and collecting metrics data. We’ve also been able to improve tor padding, testing, onion services, documentation, Tor Browser UX, and tooling for development.</p>
<p>With your support, we’ve been able to allocate time to important tickets, and we look forward to launching our second Bug Smash Fund campaign in August 2020!</p>
<p>For a list of the tickets we closed with the first half of the Bug Smash Fund, <a href="https://blog.torproject.org/tor-bug-smash-fund-progress">see our blog post from January</a>. Below is a full list of the BugSmashFund tickets we’ve closed since that update.</p>
<h3>Tor Browser</h3>
<p>The Bug Smash Fund helped the Tor Browser team complete the ESR 68 migration in late 2019, and has helped us close the following tickets since then:</p>
<ul>
<li>32174 <a href="https://gitlab.torproject.org/tpo/applications/tor-launcher/-/issues/32174">Replace XUL &lt;textbox&gt; with &lt;html:input&gt;</a></li>
<li>21549 <a href="https://gitlab.torproject.org/tpo/applications/tor-browser/-/issues/21549">Investigate wasm for linkability/fingerprint ability/disk avoidance issues</a></li>
<li>31395 <a href="https://gitlab.torproject.org/tpo/applications/tor-browser/-/issues/31395">Remove inline &lt;script&gt; in aboutTor.xhtml</a></li>
</ul>
<h3>Core Tor – Backport bug fixes, documentation, tests</h3>
<p>The Bug Smash Fund has helped the Network team to accomplish quite a bit—from improving documentation and tests to backporting bug fixes.</p>
<ul>
<li>32721 <a href="https://gitlab.torproject.org/tpo/core/chutney/-/issues/32721">Allow chutney users to disable tor's sandbox at runtime</a></li>
<li>28992 <a href="https://gitlab.torproject.org/tpo/core/tor/-/issues/28992">Bug: ../src/feature/hs/hs_client.c:571: send_introduce1: Non-fatal assertion !(ip == NULL) failed</a></li>
<li>29819 <a href="https://gitlab.torproject.org/tpo/core/tor/-/issues/29819">Seccomp: sandbox crash on rt_sigaction with libseccomp 0.2.4</a></li>
<li>30344 <a href="https://gitlab.torproject.org/tpo/core/tor/-/issues/30344">conn_read_callback is called on connections that are marked for closed</a></li>
<li>31594 <a href="https://gitlab.torproject.org/tpo/core/tor/-/issues/31594">Close all the log fds before aborting</a></li>
<li>31614 <a href="https://gitlab.torproject.org/tpo/core/tor/-/issues/31614">Implement clean_up_backtrace_handler()</a></li>
<li>31736 <a href="https://gitlab.torproject.org/tpo/core/tor/-/issues/31736">Stop using mutex_destroy(), when multiple threads can still access the mutex</a></li>
<li>32298 <a href="https://gitlab.torproject.org/tpo/core/tor/-/issues/32298">Make pkg-config a hard requirement for Android builds, since lzma requires it</a></li>
<li>32315 <a href="https://gitlab.torproject.org/tpo/core/tor/-/issues/32315">Can't perform reverse DNS lookup for a (binary) IPv6 address</a></li>
<li>32363 <a href="https://gitlab.torproject.org/tpo/core/tor/-/issues/32363">tor_inet_aton parsing of IPv4 literals is too lax</a></li>
<li>32376 <a href="https://gitlab.torproject.org/tpo/core/tor/-/issues/32376">test: Possible NULL deref in free_fake_orcirc()</a></li>
<li>32706 <a href="https://gitlab.torproject.org/tpo/core/tor/-/issues/32706">Tried to establish rendezvous on non-edge circuit</a></li>
<li>32778 <a href="https://gitlab.torproject.org/tpo/core/tor/-/issues/32778">Initialise pubsub in Windows NT service mode</a></li>
<li>32868 <a href="https://gitlab.torproject.org/tpo/core/tor/-/issues/32868">crash:  Assertion node-&gt;rs-&gt;is_possible_guard failed in compute_weighted_bandwidths at</a></li>
<li>32984 <a href="https://gitlab.torproject.org/tpo/core/tor/-/issues/32984">Revert #32883 for now and apply #32778 (so nt services can work in 0.4.3)</a></li>
<li>33103 <a href="https://gitlab.torproject.org/tpo/core/tor/-/issues/33103">LeakSanitizer is kicking in with tor being on 39c5e1b84994c2f226a8530b930f215cc5ffb877 when closing Tor Browser</a></li>
<li>33104 <a href="https://gitlab.torproject.org/tpo/core/tor/-/issues/33104">Minor issues when handling ACTIVE control signal</a></li>
<li>33192 <a href="https://gitlab.torproject.org/tpo/core/tor/-/issues/33192">Stop assuming that /usr/bin/python exists</a></li>
</ul>
<p>Thank you to everybody who made a contribution to the Bug Smash Fund. This work is critical in helping us to provide safer tools for millions of people around the world exercising their human rights to privacy and freedom online.</p>
<p>If you’d like to make a contribution to the Bug Smash Fund, you can do so by making a gift at <a href="https://donate.torproject.org">donate.torproject.org</a>: just add “Bug Smash Fund” into the comment field, and we’ll make sure it’s directed to the right place.</p>

    </div>
  <div class="categories">
    <ul><li>
        <a href="../category/applications">
          applications
        </a>
      </li><li>
        <a href="../category/fundraising">
          fundraising
        </a>
      </li><li>
        <a href="../category/network">
          network
        </a>
      </li><li>
        <a href="../category/releases">
          releases
        </a>
      </li></ul>
  </div>
  <div class="comments">
      <h2>Comments</h2>
      <p>Please note that the comment area below has been archived.</p>
      <a id="comment-288746"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-288746" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">July 19, 2020</p>
    </div>
    <a href="#comment-288746">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-288746" class="permalink" rel="bookmark">Fixing bugs and enhancing…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Fixing bugs and enhancing security/privacy are doing good work for the cause of justice and human rights everywhere!</p>
<p>I just hope that TP is never ordered by a US Court (or any other court) to fail to fix a known vulnerability, which I fear is the most likely abuse which will be encouraged by the LAEDA and EARN-IT acts if these terribly dangerous bills pass the US Congress.  (Note that both Drump and Biden have histories of opposition to unbackdoored civilian cryptography, so it is up to the US Congress to kill these proposals which will do irreparable harm to cybersecurity at the very time when Americans and indeed the USG most need strong cybersecurity.)</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-288748"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-288748" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">July 19, 2020</p>
    </div>
    <a href="#comment-288748">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-288748" class="permalink" rel="bookmark">Bug-smashing is a critical…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Bug-smashing is a critical activity for all software providers, whether FOSS or commercial.</p>
<p>Here is a recent article from Bruce Schneier which clearly explains some of the reasons why:</p>
<p>theatlantic.com<br />
The Twitter Hacks Have to Stop<br />
Twitter and companies like it are essential to the functioning of the economy and the country. The government needs to start treating them that way, and that means both requiring them to do a better job on security and breaking them up.<br />
18 Jul 2020<br />
Bruce Schneier</p>
<p>Several points he makes echoes points made by commentators in this blog:</p>
<p>o endemic cyber-insecurity in consumer devices/platforms is in fact a national security threat</p>
<p>o part of the solution involves not only regulation but breaking up the Big Tech monsters</p>
<p>o "class breaks" are particularly dangerous because there is nothing the user can do to resist them</p>
<p>In particular, it is vitally important that Tor users understand that if the proposed LAEDA or EARN-IT Acts become law, this would have the effect of a *universal* class break simulataneously rendering all cryptographic protections untrustworthy.  Disk encryption, emails, messaging, online banking.  Authentication.  Data at rest.  Data in motion.  Everything would be broken.  At the same time.</p>
<p>The only other nightmare scenario which even comes close to such universal destruction would be the discovery of an instantly exploitable break in the Rjindael cipher (aka AES, which is still the standard solution for block and stream encryption, despite its age and continuing concerns about its rather regular algebraic structure).</p>
</div>
  </div>
</article>
<!-- Comment END -->
<a id="comment-288749"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-288749" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">July 19, 2020</p>
    </div>
    <a href="#comment-288749">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-288749" class="permalink" rel="bookmark">There is lately much (long…</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>There is lately much (long overdue) discussion in US media of the role technology plays in election security.  The current vulnerabilities go far beyond securing election networks themselves (e.g. the systems used to report votes from local precincts to central election bureaus), including as well candidate websites, communications by political staffers with constituents and with their colleagues, communications by get-out-the-vote activists, interference by politicized agencies subject to authoritarian pressures, such as the US Postal Service and US Census Bureau. </p>
<p>I would like to suggest that TP leadership brainstorm how Tor can play a positive role in addressing some of these problems.</p>
<p>Two books which provide key background on state-sponsored meddling in foreign elections:</p>
<p>o CIA meddling in Italy, Latin America, etc: Tim Weiner, Legacy of Ashes, Anchor, 2007</p>
<p>o CIA meddling in Russia and Russian GRU meddling in US elections: David Shimer, Rigged, Knopf, 2020.</p>
<p>Shimer's book is an impressive first book by a young scholar (still working on his PhD!), but I fear he has been taken in by the many former CIA leaders he interviewed who stoutly insisted that CIA ceased its election meddling years ago, a misleading claim which he appears to have bought.  Far from becoming more restrained, CIA has in fact abused its ever expanding post 9/11 powers by aggressively targeting whole classes of dissidents for cyberattack, regardless of whether or not they are US citizens or persons located inside or outside US territory.  The Snowden leaks shed light upon NSA abuses, but the CIA has moved far beyond what NSA was doing to US citizens living in America.  All that said, his book is the first I have seen which offers a good discussion (albeit colored by what CIA wants us to believe) of RU hacking of US elections.</p>
<p>We need more whistleblowers, more than ever.  For this reason, I urge TP to reach out to SecureDrop to try to find ways these two platforms can work with each other in ways which help the finding and closing of current vulnerabilities, rather than the inadvertent (or USG mandated) creation of new ones.</p>
<p>Footnote: Shimer uses "bullet-point" type summaries, a useful device which I have not seen in previous scholarly books, and he does not shy away from restating important points.  Since I also use these rhetorical devices, I should state that I am not Shimer and have no ties to either Shimer or Weiner.</p>
</div>
  </div>
</article>
<!-- Comment END -->
  </div>
  </article>

</main>
    <aside class="sidebar">
<!-- ##SIDEBAR## -->
</aside>
  </section>
  <footer><div class="row download">
    <div class="col circles"></div>
    <div class="col link">
        <h3>Download Tor Browser</h3>
        <p>Download Tor Browser to experience real private browsing without tracking, surveillance, or censorship.</p>
        <a class="btn" href="https://www.torproject.org/download/">Download Tor Browser <i class="fas fa-arrow-down-png-purple"></i></a>
    </div>
</div>
<div class="row social">
    <div class="col newsletter">
        <h3>Subscribe to our Newsletter</h3>
        <p>Get monthly updates and opportunities from the Tor Project:</p>
        <p class="w"><a class="btn btn-dark" role="button" href="https://newsletter.torproject.org/">Sign up</a></p>
    </div>
    <div class="col links">
        <div class="row">
            <h4><a target="_blank" href="https://www.facebook.com/TorProject/"><i class="fab fa-facebook"></i></a></h4>
            <h4><a target="_blank" href="https://mastodon.social/@torproject" rel="me"><i class="fab fa-mastodon"></i></a></h4>
            <h4><a target="_blank" href="https://twitter.com/torproject"><i class="fab fa-twitter"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://www.instagram.com/torproject"><i class="fab fa-instagram"></i></a></h4>
            <h4><a target="_blank" href="https://www.linkedin.com/company/tor-project"><i class="fab fa-linkedin"></i></a></h4>
            <h4><a target="_blank" href="https://github.com/torproject"><i class="fab fa-github"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://t.me/torproject"><i class="fab fa-telegram"></i></a></h4>
        </div>
    </div>
</div>
<div class="row notice">
    <p>Trademark, copyright notices, and rules for use by third parties can be found in our <a href="https://www.torproject.org/about/trademark/">FAQ</a>.</p>
</div></footer>
</body>
</html>
